/* -*-C++-*-
 * ###################################################################
 *  Cpptcl - connecting C++ with Tcl
 * 
 *  FILE: "cpptcl_matrix.h"
 *                                    created: 18/9/97 {11:24:24 am} 
 *                                last update: 28/10/97 {11:44:13 am} 
 *  Author: Vince Darley
 *  E-mail: <darley@fas.harvard.edu>
 *    mail: Division of Engineering and Applied Sciences, Harvard University
 *          Oxford Street, Cambridge MA 02138, USA
 *     www: <http://www.fas.harvard.edu/~darley/>
 *  
 * ========================================================================
 *               Copyright (c) 1997 Vince Darley
 * ========================================================================
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that the copyright notice and warranty disclaimer appear in
 * supporting documentation.
 * 
 * Vince Darley disclaims all warranties with regard to this software,
 * including all implied warranties of merchantability and fitness.  In
 * no event shall Vince Darley be liable for any special, indirect or
 * consequential damages or any damages whatsoever resulting from loss of
 * use, data or profits, whether in an action of contract, negligence or
 * other tortuous action, arising out of or in connection with the use or
 * performance of this software.
 * ========================================================================
 *  Description: 
 * 
 *  History
 * 
 *  modified by  rev reason
 *  -------- --- --- -----------
 *  18/9/97  VMD 1.0 original
 * ###################################################################
 */

#ifndef _Cpptcl_cpptcl_matrix_
#define _Cpptcl_cpptcl_matrix_

#include "cpptcl.h"
#include "tclMatrix.h"

extern "C" tclMatrix* Cppmatrix_GetMatrixPtr(Tcl_Interp *interp, const char *matName);

class cpptcl_matrix: public tcl_object {
	friend tclMatrix* Cppmatrix_GetMatrixPtr(Tcl_Interp *interp, const char *matName);
  public:
	cpptcl_matrix(tcl_args& arg);
	~cpptcl_matrix(void);
	int parse_tcl_command(tcl_args& arg);
	Cpptcl_Class(cpptcl_matrix);
	int parse_configuration_values(tcl_args& arg);
	int initialise(int dim, int offs, int nargs, const Tcl_Obj** obj);
	int put_get(tcl_args& arg);

	int dim(void) const;
	
  protected:
	class tclMatrix mat;
  private:
};

#endif
