/* -*-C++-*-
 * ###################################################################
 * 
 *	FILE: "plcpp_args.cc"
 *									  created: 19/7/96 {5:51:17 pm}	
 *								  last update: 16/1/98 {8:55:35 pm}	
 *	Author:	Vince Darley
 *	E-mail:	<darley@fas.harvard.edu>
 *	  mail:	Division of	Applied	Sciences, Harvard University
 *			Oxford Street, Cambridge MA	02138, USA
 *	   www:	<http://www.fas.harvard.edu/~darley/>
 *	
 * ###################################################################
 */


#include "plcpp_args.h"

tcl_args& plcpp_matrix_read (tcl_args& arg, TclMatInt& into, int dim){
	arg.set_conversion_type("Integer-Matrix");
	const char* t;
	arg.const_string_read(t);
	if(!t){
		(void)into;
	} else {
		tclMatrix* mat = Tcl_GetMatrixPtr(arg,t);
		if(mat && mat->type == TYPE_INT && mat->dim == dim) {
			into.matPtr = mat;
			arg.parsed_so_far << t;
		} else {
			arg.signal_error(tcl_args::Conversion);
		}
	}
	arg.read_done();
	return arg;
}

tcl_args& plcpp_matrix_read(tcl_args& arg, TclMatFloat& into, int dim){
	arg.set_conversion_type("Real-Matrix");
	const char* t;
	arg.const_string_read(t);
	if(!t){
		(void)into;
	} else {
		tclMatrix* mat = Tcl_GetMatrixPtr(arg,t);
		if(mat && mat->type == TYPE_FLOAT && mat->dim == dim) {
			into.matPtr = mat;
			arg.parsed_so_far << t;
		} else {
			arg.signal_error(tcl_args::Conversion);
		}
	}
	arg.read_done();
	return arg;

}
