# simple test script for Pltk 
# get package Pltk -- automatically loads the matrix package too
package require Pltk
console show

proc           stdio_puts_stdout   string {}
proc                     stdio_puts_stderr   string {}
proc                    stdio_read          bytes {}

# make an extended plframe
plxframe .p
.p configure -width 200 -height 200
pack .p -fill both -expand true

# create a matrix 
matrix d f 10 10
for { set x 0 } { $x < 10 } { incr x } { 
	for {set y 0} { $y < 10} {incr y} { 
		d $x $y = [expr sin(($x * $x + $y * $y)/2)] 
	} 
}

# set up the axes
.p.plwin cmd plcol 15
.p.plwin cmd plenv 0 10 0 10 1 1
.p.plwin cmd pllab "x" "y" "Test plot"

# plot
set numberOfShades 10
set min -1.0
set max 1.0
set xmin 0
set xmax 10
set ymin 0
set ymax 10
for {set i 0} {$i < $numberOfShades } {incr i} {
	set sh_min [expr $min + ($max-$min)*$i/$numberOfShades]
	set sh_max [expr $min + ($max-$min)*($i+1)/$numberOfShades]
	set sh_col [expr $i/$numberOfShades.]
	if { $sh_min == $sh_max } { incr sh_max }
	.p.plwin cmd plshade d $xmin $xmax $ymin $ymax $sh_min $sh_max 1 $sh_col
	puts ".p.plwin plshade d $xmin $xmax $ymin $ymax $sh_min $sh_max 1 $sh_col"
}




